From 8a3c38753725bea0637921579b3bf9fe0a0fd46b Mon Sep 17 00:00:00 2001
From: Jie Tang <tangjie18@huawei.com>
Date: Thu, 14 May 2020 17:05:07 +0800
Subject: [PATCH 21/28] env_process: verify command for aarch64 to check device
 category.

For example, aarch64 use 'qemu-kvm -M virt -device help' to get qemu device info.

Signed-off-by: Jie Tang <tangjie18@huawei.com>
---
 virttest/env_process.py | 5 +++++
 1 file changed, 5 insertions(+)

diff --git a/virttest/env_process.py b/virttest/env_process.py
index 947a129e..cb17aefc 100644
--- a/virttest/env_process.py
+++ b/virttest/env_process.py
@@ -15,6 +15,7 @@ except ImportError:
     from urllib2 import ProxyHandler, build_opener, install_opener
 
 import aexpect
+import platform
 from avocado.utils import process as a_process
 from avocado.utils import crypto
 from avocado.utils import path
@@ -1035,6 +1036,10 @@ def preprocess(test, params, env):
 
     if vm_type == "qemu":
         qemu_path = utils_misc.get_qemu_binary(params)
+        # aarch64 use "qemu-kvm -M machine_type" instead.
+        if platform.machine() == 'aarch64':
+            machine_type = params.get("machine_type").split(':', 1)[1]
+            qemu_path = qemu_path + " -M" + " %s" % machine_type
         if (utils_qemu.has_device_category(qemu_path, "CPU")
                 and params.get("cpu_driver") is None):
             cpu_model = params.get("cpu_model")
-- 
2.23.0

